


function loadScript(url, callback) {
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = url;

    // 脚本加载完成后执行回调
    script.onload = function () {
        if (typeof callback === 'function') {
            callback();
        }
    };

    // 将脚本添加到 <head> 中
    document.head.appendChild(script);
}

function loadCSS(url, id) {
    // 检查是否已经存在相同的 <link> 元素
    if (id && document.getElementById(id)) {
        console.log('CSS 已经加载：', url);
        return;
    }

    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = url;

    // 如果提供了 id，则设置以避免重复加载
    if (id) {
        link.id = id;
    }

    // 监听加载事件
    link.onload = function () {
        console.log('CSS 加载完成：', url);
        // 在这里可以执行需要在 CSS 加载后进行的操作
    };

    // 监听错误事件
    link.onerror = function () {
        console.error('CSS 加载失败：', url);
        // 在这里可以进行错误处理
    };

    // 将 <link> 元素添加到 <head> 中
    document.head.appendChild(link);
}
loadCSS('https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/codemirror.min.css', 'codemirror-css');

loadScript('https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/codemirror.min.js', function () {
    console.log('CodeMirror 脚本已加载完成');
    loadScript('https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.12/mode/javascript/javascript.min.js', function () {
        console.log('javascript min 脚本已加载完成');

    });
});



// loadCSS(`${contentAISEOAdmin.plugin_url}assets/css/codemirror.min.css`, 'codemirror-css');

// loadScript(`${contentAISEOAdmin.plugin_url}assets/otherjs/codemirror.min.js`, function () {
//     console.log('CodeMirror 脚本已加载完成');
//     loadScript(`${contentAISEOAdmin.plugin_url}assets/otherjs/javascript.min.js`, function () {
//         console.log('javascript min 脚本已加载完成');
//         // 在这里初始化 CodeMirror 或进行其他操作
//     });
// });


window.addEventListener("DOMContentLoaded", function () {
    layui.use(['table'], function () {
        var editor = null;
        var element = layui.element;
        var util = layui.util;
        var table = layui.table;
        var form = layui.form;
        var util = layui.util;
        var $ = layui.$;

        var db2 = new PromptDatabase();
        var articleGeneratorLayerindex = null
        var articlePrompt = ''
        var articleOutline = ''
        var typeofGenerator = 'G1'

        const mtabchange = ((layid, title, content) => {
            if (document.querySelector(`[lay-id=\"${layid}\"]`)) {
                element.tabDelete('articleGenerator-handle', layid);
            }
            element.tabAdd('articleGenerator-handle', {
                title: title,
                content: content,
                id: layid, // 实际使用一般是规定好的id，这里以毫秒数模拟
                change: true // 是否添加完毕后即自动切换
            })
            element.tabChange('articleGenerator-handle', layid);
        })


        const formatJSON = ((containerID) => {
            let textarea = document.getElementById(containerID);
            try {
                let jsonObj = JSON.parse(editor.getValue());
                editor.setValue(JSON.stringify(jsonObj, null, 4)); // 重新格式化

            } catch (error) { }
        })

        const outlinePromptsetting = (() => {
            const ApplyOutlineArticleGenerator = document.getElementById("ApplyOutlineArticleGenerator")
            ApplyOutlineArticleGenerator.addEventListener('click', () => {
                let prompt = document.getElementById('outlineArticleGeneratorSelect').value;
                if (prompt == '') {
                    alert('please select a prompt')
                    setFocusAndHighlightAss('outlineArticleGeneratorSelect')
                    return
                }
                layer.open({
                    title: "Setting",
                    type: 1,
                    offset: 'l',
                    anim: 'slideRight', // 从右往左
                    content: `<div id="" class="containerbutton"><button id="confirmArticleprompt" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button id="articlePromptpart" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button id="articlePromptEmptyPart" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button></div><div id="articlePromptcontainer"></div>`,
                    area: ['480px', '100%'], // 初始宽高
                    maxmin: true,
                    shade: 0,
                    // shadeClose: true,
                    success: function (layero, index) {
                        db2.getPromptByName(prompt).then((res) => {

                            promptDomGenerator(res['prompt'], 'articlePromptcontainer')
                        })

                        $('#confirmArticleprompt').on('click', async function () {
                            let createContentInput = getAllValueInput('articlePromptcontainer')
                            articleOutline = promptGenerator(createContentInput)
                            // document.querySelector("#bulkgeneratorImginfopromptcontainer").innerHTML = `<h3>Prompt: </h3>${allImgsPrompts}`

                            let outline = null
                            let result = await mergePromptSend(prompt = articleOutline, save = '00', returncounts = 1, jsonformat = '11')
                            outline = result['dataresult']
                            // outline   = localStorage.getItem("postarticle")//缓存数据，调试程序的时候可以用上

                            try {
                                outline = JSON.parse(outline)
                            } catch (error) {
                                mlog(error, 'outline')
                                //修复model search_preview带来的错误

                                let outline_ = extractJson(outline[0])
                                outline = JSON.parse(outline_)
                            }

                            //请求chatgpt,返回总纲prompt

                            outline = JSON.stringify(outline)
                            editor.setValue(outline)
                            editor.setSize("100%", "100%");
                            // 强制刷新 CodeMirror，解决初始化时不显示内容的问题
                            setTimeout(function () {
                                editor.refresh();
                            }, 100);
                            formatJSON('jsonEditor-ass')
                            layer.close(index);
                        })
                        $('#articlePromptEmptyPart').on('click', function () {
                            addcomponet({
                                'title': 'label',
                                'content': 'content'
                            }, 'articlePromptcontainer')
                        })
                        $('#articlePromptpart').on('click', function () {
                            AIassistantquickpromptpartfunction('articlePromptcontainer', 'r')
                        })
                        $('#formatJSON').on('click', function () {
                            formatJSON('jsonEditor-ass')
                        })
                    }
                });
            })
        });


        util.on('lay-on', {
            'articleGenerator': function () {
                if (articleGeneratorLayerindex) {

                    layer.msg('Layer is already open!', { icon: 5 });
                    return;
                }

                const settingDOM = `<div id="articleGeneratorContainer" class="layui-tab layui-tab-color" lay-filter="articleGenerator-handle" lay-allowclose="true">
                                        <ul class="layui-tab-title">
                                            <li class="layui-this" lay-allowclose="false">Choose the type of article generator</li>
                                        </ul>
                                        <div style="padding: 12px;" class="layui-tab-content">
                                            <div class="layui-tab-item layui-show">
                                                <div class="layui-btn-container">
                                                    <button id="c1" lay-on="Choosetypeofgenerator" type="button" class="layui-btn layui-btn-warm">Base on outline</button>
                                                    <button id="c2" lay-on="Choosetypeofgenerator" type="button" class="layui-btn layui-btn-warm">Base on exploration prompt</button>
                                                    <button id="c3" lay-on="Choosetypeofgenerator" type="button" class="layui-btn layui-btn-warm">Base on book TOC</button>
                                                    <button id="c4" lay-on="Choosetypeofgenerator" type="button" class="layui-btn layui-btn-warm">Simple</button>
                                                    <button id="c5" lay-on="Choosetypeofgenerator" type="button" class="layui-btn layui-btn-warm">Base on attributes</button>
                                                    <button id="c6" lay-on="Choosetypeofgenerator" type="button" class="layui-btn layui-btn-warm">Base on article structure</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>`

                // 在此处输入 layer 的任意代码
                articleGeneratorLayerindex = layer.open({
                    type: 1, // page 层类型
                    area: ['800px', '600px'],
                    title: 'Article Generator',
                    shade: 0, // 遮罩透明度
                    shadeClose: false, // 点击遮罩区域，关闭弹层
                    maxmin: true, // 允许全屏最小化
                    anim: 0, // 0-6 的动画形式，-1 不开启
                    content: settingDOM,
                    btn: ['Close'],
                    yes: function (index, layero) {
                        // 关闭弹出层时清除 index
                        layer.close(index);
                        articleGeneratorLayerindex = null;
                    },
                    // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
                    end: function () {
                        articleGeneratorLayerindex = null;
                    }
                });
            },
            'Choosetypeofgenerator': function (othis) {

                if (typeof CodeMirror === 'undefined') {
                    alert('loading,please wait a minute')
                    return
                }

                element.tabDelete('articleGenerator-handle', '12'); // 
                element.tabDelete('articleGenerator-handle', '13'); // 
                element.tabDelete('articleGenerator-handle', '14'); // 
                element.tabDelete('articleGenerator-handle', '15'); // 
                if (['c1', 'c2', 'c3', 'c5', 'c6'].includes(othis[0].id)) {
                    if (othis[0].id == 'c1') {
                        typeofGenerator = "G1"
                        var title = '2.Base on Outline Article Generator'
                        var noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the AI Assistant category, the prompts can be customized within the "PromptOutlineGenerator" tag.</span>`

                    }
                    else if (othis[0].id == 'c2') {
                        typeofGenerator = "G2"
                        var title = '2.Base on exploration prompt Article Generator'
                        var noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the AI Assistant category, the prompts can be customized within the "PromptExplorationGenerator" tag.</span>`

                    }
                    else if (othis[0].id == 'c3') {
                        typeofGenerator = "G3"
                        var title = '2.Base on Book TOC Article Generator'
                        var noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the AI Assistant category, the prompts can be customized within the "PromptBookTOCGenerator" tag.</span>`

                    }
                    else if (othis[0].id == 'c5') {
                        typeofGenerator = "G5"
                        var title = '2.Base on Attributes Article Generator'
                        var noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the AI Assistant category, the prompts can be customized within the "PromptAttributesGenerator" tag.</span>`

                    }
                    else if (othis[0].id == 'c6') {
                        typeofGenerator = "G6"
                        var title = '2.Base on Structure Article Generator'
                        var noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the AI Assistant category, the prompts can be customized within the "PromptArticleStructureGenerator" tag.</span>`

                    }
                    let layid = '12'
                    let content = `<div class="layui-btn-container"><button id="GoOnGenerateArticle1" lay-on="GoOnGenerateArticle12" class="layui-btn layui-btn-warm">1.2 Go on Generate</button><button id="formatJSON" class="layui-btn layui-btn-warm">Format JSON</button></div><select id="outlineArticleGeneratorSelect"></select><button id="ApplyOutlineArticleGenerator" class="layui-btn layui-btn-sm layui-btn-warm">Apply</button>${noteforcustomized}<textarea id="jsonEditor-ass"></textarea>`
                    // var title = '2.Base on Outline Article Generator'
                    mtabchange(layid, title, content)

                    editor = CodeMirror.fromTextArea(document.getElementById('jsonEditor-ass'), {
                        mode: "application/json",
                        theme: "default",
                        lineNumbers: true,
                        matchBrackets: true,
                        autoCloseBrackets: true,
                        lineWrapping: true      // Enable line wrapping

                    });

                    let selectElement = document.getElementById('outlineArticleGeneratorSelect');
                    let tag = ''
                    if (othis[0].id == "c1") {
                        tag = 'PromptOutlineGenerator'
                    }
                    else if (othis[0].id == "c2") {
                        tag = 'PromptExplorationGenerator'
                    }
                    else if (othis[0].id == "c3") {
                        tag = 'PromptBookTOCGenerator'
                    }
                    else if (othis[0].id == "c5") {
                        tag = 'PromptAttributesGenerator'
                    }
                    else if (othis[0].id == "c6") {
                        tag = 'PromptArticleStructureGenerator'
                    }
                    db2.getAllPromptByTag(tag).then(res => {
                        console.log(res)
                        // 调用函数填充选项
                        populateOptionsFromArrayAss(res, selectElement);
                        selectElement.addEventListener("change", async (event) => {
                        })
                        outlinePromptsetting()

                    })
                }
                else if (othis[0].id == 'c4') {
                    typeofGenerator = "G4"
                    let layid = '12'
                    let content = `<div class="layui-btn-container"><button id="GoOnGenerateArticle4" lay-on="GoOnGenerateArticle12" class="layui-btn layui-btn-warm">1.2 Go on Generate</button>`
                    let title = '2.Simple Article Generator'
                    mtabchange(layid, title, content)
                }
            },
            'GoOnGenerateArticle12': function (othis) {

                if (othis[0].id != 'GoOnGenerateArticle4') {
                    articleOutline = editor.getValue()
                    if (articleOutline == "") {
                        alert('empty content,please generate outline or TOC... first')
                        setFocusAndHighlightAss('ApplyOutlineArticleGenerator')
                        return
                    }
                }

                let tag = ''
                let noteforcustomized = ''
                if (othis[0].id == 'GoOnGenerateArticle1') {
                    if (typeofGenerator == "G1") {
                        tag = 'ArticleOutlineGenerator'
                        noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the "AI Assistant" category, the prompts can be customized within the "ArticleOutlineGenerator" tag.</span>`
                    }
                    else if (typeofGenerator == "G2") {
                        tag = 'ArticleExplorationGenerator'
                        noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the "AI Assistant" category, the prompts can be customized within the "ArticleExplorationGenerator" tag.</span>`

                    }
                    else if (typeofGenerator == "G3") {
                        tag = 'ArticleBookTOCGenerator'
                        noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the "AI Assistant" category, the prompts can be customized within the "ArticleBookTOCGenerator" tag.</span>`

                    }
                    else if (typeofGenerator == "G5") {
                        tag = 'ArticleAttributesGenerator'
                        noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the "AI Assistant" category, the prompts can be customized within the "ArticleAttributesGenerator" tag.</span>`

                    }
                    else if (typeofGenerator == "G6") {
                        tag = 'ArticleGeneratorForStructure'
                        noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the "AI Assistant" category, the prompts can be customized within the "ArticleGeneratorForStructure" tag.</span>`

                    }
                }
                else if (othis[0].id == 'GoOnGenerateArticle4') {
                    tag = 'ArticleSimpleGenerator'
                    noteforcustomized = `<span class="noteforcustomized" style="color:red;">Note: In the "AI Assistant" category, the prompts can be customized within the "ArticleSimpleGenerator" tag.</span>`

                }

                let layid = '13'
                let content = `<div class="layui-btn-container"><button lay-on="GoOnGenerateArticle13" class="layui-btn layui-btn-warm">1.3 Go on Generate</button></div><select id="articlePromptSelect"></select><button id="ApplyArticlePrompt" class="layui-btn layui-btn-sm layui-btn-warm">Apply</button>${noteforcustomized}<div id="thisArticlePromptContainer" class="promptcontainer"></div>`
                let title = '3.Choose the article prompt and setting'
                mtabchange(layid, title, content)

                let selectElement = document.getElementById('articlePromptSelect');


                db2.getAllPromptByTag(tag).then(res => {
                    console.log(res)
                    // 调用函数填充选项
                    populateOptionsFromArrayAss(res, selectElement);
                    selectElement.addEventListener("change", async (event) => {
                    })
                    const articlepromptsetting = (() => {
                        const ApplyArticlePrompt = document.getElementById("ApplyArticlePrompt")
                        ApplyArticlePrompt.addEventListener('click', () => {
                            let prompt = document.getElementById('articlePromptSelect').value;
                            if (prompt == '') {
                                alert('please select a prompt')
                                setFocusAndHighlightAss('ApplyArticlePrompt')
                                return
                            }
                            layer.open({
                                title: "Setting",
                                type: 1,
                                offset: 'l',
                                anim: 'slideRight', // 从右往左
                                content: `<div id="" class="containerbutton"><button id="confirmArticleprompt1" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Confirm</button><button id="articlePromptpart" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Prompt part</button><button id="articlePromptEmptyPart" type="button" class="layui-btn layui-btn-warm layui-btn-radius">Empty Part</button></div><div id="articlePromptcontainer"></div>`,
                                area: ['480px', '100%'], // 初始宽高
                                maxmin: true,
                                shade: 0,
                                // shadeClose: true,
                                success: function (layero, index) {
                                    db2.getPromptByName(prompt).then((res) => {

                                        promptDomGenerator(res['prompt'], 'articlePromptcontainer')
                                    })

                                    $('#confirmArticleprompt1').on('click', function () {
                                        let createContentInput = getAllValueInput('articlePromptcontainer')
                                        articlePrompt = promptGenerator(createContentInput)
                                        if (['G1', 'G2', 'G3', 'G5', 'G6'].includes(typeofGenerator)) {

                                            if (typeofGenerator == "G1") {
                                                articlePrompt = `${articlePrompt}Outline: ${articleOutline}<br>`
                                            }
                                            else if (typeofGenerator == "G2") {
                                                articlePrompt = `${articlePrompt}More Requirement: ${articleOutline}<br>`
                                            }
                                            else if (typeofGenerator == "G3") {
                                                articlePrompt = `${articlePrompt}Outline: ${articleOutline}<br>`
                                            }
                                            else if (typeofGenerator == "G5") {
                                                articlePrompt = `${articlePrompt}Attributes: ${articleOutline}<br>`
                                            }
                                            else if (typeofGenerator == "G6") {
                                                articlePrompt = `${articlePrompt}Article Structure: ${articleOutline}<br>`
                                            }
                                        }
                                        document.querySelector("#thisArticlePromptContainer").innerHTML = `<h3>Prompt: </h3>${articlePrompt}`

                                        layer.close(index);

                                    })
                                    $('#articlePromptEmptyPart').on('click', function () {
                                        addcomponet({
                                            'title': 'label',
                                            'content': 'content'
                                        }, 'articlePromptcontainer')
                                    })
                                    $('#articlePromptpart').on('click', function () {
                                        AIassistantquickpromptpartfunction('articlePromptcontainer', 'r')
                                    })
                                }
                            });
                        })
                    });
                    articlepromptsetting()
                })


            },
            'GoOnGenerateArticle13': async function () {
                if (articlePrompt == '') {
                    alert('empty prompt,please select article prompt first')
                    setFocusAndHighlightAss('ApplyArticlePrompt')
                    return
                }
                //请求AI获取数据
                let articlecontent = {}
                let result = await mergePromptSend(articlePrompt, save = '00', returncounts = 1, jsonformat = '11')
                articlecontent = result['dataresult']
                // articlecontent=localStorage.getItem("postarticle2")//缓存数据，调试程序的时候可以用上

                try {
                    // outline = JSON.parse(outline)
                    articlecontent = JSON.parse(articlecontent)
                } catch (error) {
                    mlog(error, 'articlecontent')
                    //修复model search_preview带来的错误
                    let articlecontent_ = extractJson(articlecontent[0])
                    articlecontent = JSON.parse(articlecontent_)
                }


                mlog(articlecontent, '###articlecontent')
                //json key一律变成小写
                articlecontent = normalizeKeys(articlecontent)


                let layid = '14'
                let content = `<table lay-filter="articleGeneratorResult" class="layui-hide" id="ID-table-articleGeneratorResult"></table>`
                let title = '4.Result'
                mtabchange(layid, title, content)

                var tdata = []
                // subsectionTitles.forEach((ele, key) => {
                // let m = {
                //     "title": 'title',
                //     "description": "description",
                //     "excerpt": "excerpt",
                //     "outline": "outline",
                //     "articlebody": "articlebody"
                // }
                let m = {
                    "title": articlecontent['title'] ?? "",
                    "description": articlecontent['description'] ?? "",
                    "excerpt": articlecontent['excerpt'] ?? "",
                    "outline": 'outline',
                    "articlebody": articlecontent['articlebody'] ?? "",
                    "keywords": articlecontent['keywords'] ?? "",
                    "open_graph": ensureString(articlecontent['open_graph']) ?? "",
                    "twitter_card": ensureString(articlecontent['twitter_card']) ?? ""
                }
                tdata.unshift(m)
                // });

                var inst = table.render({
                    toolbar: '#toolbar', // 启用工具条
                    elem: '#ID-table-articleGeneratorResult',
                    lineStyle: 'height: 165px;',
                    cols: [
                        [ //标题栏
                            {
                                title: 'Action',
                                toolbar: '#table-operations-articlegenerator',
                            },
                            {
                                field: 'title',
                                title: 'title',
                            },
                            {
                                field: 'description',
                                title: 'description',
                            },
                            {
                                field: 'excerpt',
                                title: 'excerpt',
                            },
                            {
                                field: 'keywords',
                                title: 'keywords',
                            },
                            {
                                field: 'open_graph',
                                title: 'open_graph',
                            },
                            {
                                field: 'twitter_card',
                                title: 'twitter_card',
                            },
                            {
                                field: 'outline',
                                title: 'outline',
                            },
                            {
                                field: 'articlebody',
                                title: 'articlebody',
                            },
                        ]
                    ],
                    data: tdata,
                    page: true, // 是否显示分页
                    limit: 5 // 每页默认显示的数量
                });
                // 设置表格行高
                // $('.layui-table td').css({
                //     'line-height': '150px'  // 设置行高
                // });

                table.on('tool(articleGeneratorResult)', function (obj) {
                    var data = obj.data; // 当前行的数据
                    var event = obj.event; // lay-event 的值
                    if (event === 'applyarticle') {

                        wp.domReady(() => {
                            // 设置文章标题
                            // 替换#
                            let title = data.title.replace(/#/g, '');
                            wp.data.dispatch('core/editor').editPost({ title: title });

                            // 设置文章摘要（Excerpt）
                            wp.data.dispatch('core/editor').editPost({ excerpt: data.excerpt });

                            // 设置 Yoast SEO 插件的元描述（如果你使用的是 Yoast SEO）
                            if (typeof yoast !== 'undefined' && yoast !== null) {
                                wp.data.dispatch('yoast-seo/editor').setMetaValue('yoast_wpseo_metadesc', data.description);
                            }

                            document.getElementById('content_ai_seo_description').value = data.description;
                            document.getElementById('content_ai_seo_keywords').value = data.keywords
                            document.getElementById('content_ai_seo_open_graph').value =processOpengraph(data.open_graph)
                            document.getElementById('content_ai_seo_twitter_card').value = processOpengraph(data.twitter_card)


                            // 将 Markdown 转换为 HTML
                            // const htmlArticlebody = marked.parse(data.articlebody);

                            //过滤掉文章主体markdown中多余的h1标题
                            let articlebody = data.articlebody.replace(/^# .*\n?/gm, '')

                            const htmlArticlebody = marked.parse(articlebody, {
                                // gfm: false, // 关闭 GitHub Markdown 格式
                                // breaks: true // 保留换行符，避免自动转换为 <p>
                            });
                            // paragraph
                            // const paragraphBlock = wp.blocks.createBlock('core/html', {
                            //         content: htmlArticlebody,
                            // });

                            const blocks = wp.blocks.rawHandler({ HTML: htmlArticlebody });

                            wp.data.dispatch('core/block-editor').insertBlocks(blocks);

                            // 插入段落块
                            // wp.data.dispatch('core/block-editor').insertBlocks(paragraphBlock);

                        });

                        alert('Done')
                    }


                });
            },
            'GoOnGenerateArticle1': function () {

            }
        })
    })
})


var atitle = `连衣裙指南：挑选、搭配与保养全方位攻略`
var description = `了解连衣裙的款式分类、选购技巧、搭配指南及保养方法，帮助你找到最适合的连衣裙，展现优雅气质与个性魅力。`
var excerpt = `连衣裙是女性衣橱中不可或缺的单品。本文详细介绍连衣裙的种类、选购技巧、搭配方案及护理方法，助你提升穿搭品味`
var articleBody = `### **连衣裙指南**

#### **Title:**  
连衣裙指南：挑选、搭配与保养全方位攻略  

#### **Description:**  
了解连衣裙的款式分类、选购技巧、搭配指南及保养方法，帮助你找到最适合的连衣裙，展现优雅气质与个性魅力。  

#### **Excerpt:**  
连衣裙是女性衣橱中不可或缺的单品。本文详细介绍连衣裙的种类、选购技巧、搭配方案及护理方法，助你提升穿搭品味。  

---

### **ArticleBody**  

#### **1. 引言**  

##### **1.1 连衣裙的定义与特点**  
连衣裙是一种上衣与裙子连在一起的服饰，款式多样，适用于各种场合。其主要特点包括：  
- **一体式设计**：穿脱方便，省去搭配的烦恼。  
- **多样风格**：从简约休闲到奢华礼服，应有尽有。  
- **季节适应性强**：不同材质适合四季穿搭，如夏季轻薄雪纺，冬季呢料加厚款。  

##### **1.2 连衣裙的流行趋势**  
时尚潮流不断变化，但连衣裙始终是设计师们青睐的单品。近年来，以下几种趋势备受关注：  
- **极简风连衣裙**：强调线条感与剪裁，适合日常穿搭。  
- **法式复古连衣裙**：蕾丝、泡泡袖、碎花元素回归经典。  
- **多功能连衣裙**：可变换穿法，如绑带设计或可拆卸裙摆。  

---

#### **2. 连衣裙的分类**  

##### **2.1 按照款式分类**  
不同款式的连衣裙适用于不同身材和场合，例如：  
- **A字裙**：适合各种体型，修饰腿部线条。  
- **裹身裙**：贴合身形，展现曲线美，适合职场或宴会。  
- **公主裙**：适合甜美风格人士，常见于婚礼或正式场合。  

##### **2.2 按照面料分类**  
面料决定了连衣裙的舒适度和视觉效果，如：  
- **棉麻**：透气舒适，适合春夏。  
- **丝绸**：轻盈顺滑，提升高级感。  
- **蕾丝**：增添女性柔美气质，适合正式场合。  

##### **2.3 按照场合分类**  
根据穿着需求，可分为：  
- **休闲连衣裙**：日常出行，简约舒适。  
- **职场连衣裙**：剪裁利落，展现专业感。  
- **宴会连衣裙**：华丽设计，强调气场。  

---

#### **3. 如何选择适合的连衣裙**  

##### **3.1 根据体型选择合适的连衣裙**  
- **梨形身材**：适合A字裙或高腰设计，遮掩臀部。  
- **苹果身材**：推荐直筒裙，避免过于紧身的款式。  
- **高瘦身材**：长款连衣裙凸显优雅气质。  

##### **3.2 根据肤色搭配适合的颜色**  
- **暖色调肤色**：适合米色、红色、棕色等暖色系。  
- **冷色调肤色**：推荐蓝色、紫色、灰色等冷色调。  
- **中性色肤色**：可以驾驭多种颜色，如黑白灰等经典色。  

##### **3.3 根据季节挑选适宜的材质**  
- **春夏季**：轻薄透气，如雪纺、棉麻。  
- **秋冬季**：厚实保暖，如羊毛、针织面料。  

---

#### **4. 连衣裙的搭配指南**  

##### **4.1 配饰的选择**  
连衣裙可搭配不同配饰来提升整体造型：  
- **鞋子**：高跟鞋增加气场，运动鞋营造休闲风。  
- **包包**：手拿包适合正式场合，斜挎包适合日常穿搭。  
- **首饰**：简约项链适合通勤风，大耳环增添个性。  

##### **4.2 不同风格的搭配技巧**  
- **法式优雅风**：碎花连衣裙+草编包+尖头鞋。  
- **极简通勤风**：黑色直筒裙+西装外套+乐福鞋。  
- **甜美可爱风**：蕾丝连衣裙+玛丽珍鞋+珍珠耳环。  

##### **4.3 如何打造个性化穿搭**  
- **叠搭技巧**：冬季可用毛衣、外套进行层次搭配。  
- **腰带点缀**：强调腰部线条，提升比例感。  
- **颜色对比**：通过对比色或同色系搭配打造时尚感。  

---

#### **5. 连衣裙的护理与保养**  

##### **5.1 不同材质的清洗方法**  
- **棉麻类**：可机洗，但需低温熨烫防止缩水。  
- **丝绸类**：建议干洗，避免高温和暴晒。  
- **蕾丝类**：手洗最佳，以免损坏精细纹理。  

##### **5.2 存放与保养技巧**  
- **悬挂存放**：避免衣物变形，尤其是长裙类。  
- **使用防尘袋**：保护高级面料不受污染。  
- **防止褪色**：深色衣物需单独存放，避免阳光直射。  

##### **5.3 如何延长连衣裙的使用寿命**  
- **定期清洁**：防止污渍沉积影响美观。  
- **适当更换**：避免过度穿着导致磨损。  
- **专业护理**：针对特殊材质，可送至干洗店进行护理。  

---

#### **6. 结论**  

##### **6.1 选择合适连衣裙的重要性**  
连衣裙不仅是一件衣物，更是展现个人风格的重要元素。选对连衣裙，不仅能修饰身材，还能提升自信心。  

##### **6.2 穿搭自信展现个人风格**  
每个人的风格独特，关键在于找到适合自己的连衣裙并大胆尝试不同搭配方式，让每一次穿搭都展现最美的自己。  

---

### **总结**  
本指南详细解析了连衣裙的分类、选购、搭配及保养技巧，帮助你找到最适合的连衣裙款式。无论是日常通勤、约会聚会还是正式场合，只要掌握连衣裙的穿搭法则，你都能自信展现优雅魅力。`