
function onLayuiReady(callback) {
    if (typeof layui !== 'undefined') {
        callback();
    } else {
        setTimeout(function () {
            onLayuiReady(callback);
        }, 50); // 每50ms检查一次
    }
}

window.addEventListener("DOMContentLoaded", function () {
    onLayuiReady(function () {
        layui.use(['table'], function () {
            var editor = null;
            var element = layui.element;
            var util = layui.util;
            var table = layui.table;
            var form = layui.form;
            var util = layui.util;
            var $ = layui.$;

            var editor = null

            var chartGeneratorLayerindex = null

            // const formatJSON = ((containerID) => {
            //     // let textarea = document.getElementById(containerID);
            //     try {
            //         let jsonObj = JSON.parse(editor.getValue());
            //         editor.setValue(JSON.stringify(jsonObj, null, 4)); // 重新格式化
            //     } catch (error) { }
            // })

            const mtabchange = ((layid, title, content) => {
                if (document.querySelector(`[lay-id=\"${layid}\"]`)) {
                    element.tabDelete('chartGenerator-handle', layid);
                }
                element.tabAdd('chartGenerator-handle', {
                    title: title,
                    content: content,
                    id: layid, // 实际使用一般是规定好的id，这里以毫秒数模拟
                    change: true // 是否添加完毕后即自动切换
                })
                element.tabChange('chartGenerator-handle', layid);
            })

            util.on('lay-on', {
                'echartfunc': function () {

                    if (chartGeneratorLayerindex) {

                        layer.msg('Layer is already open!', { icon: 5 });
                        return;
                    }

                    const settingDOM = `<div id="chartGeneratorContainer" class="layui-tab layui-tab-color" lay-filter="chartGenerator-handle" lay-allowclose="true">
                                        <ul class="layui-tab-title">
                                            <li class="layui-this" lay-allowclose="false">Choose the type of chart generator</li>
                                        </ul>
                                        <div style="padding: 12px;" class="layui-tab-content">
                                            <div class="layui-tab-item layui-show">
                                                <div class="layui-row layui-col-space16">
                                                    <div class="layui-col-md6">
                                                        <select id="selectchart">
                                                        <option value="">Select a chart</option>
                                                        </select>
                                                        <button lay-on="applychart" id="applychart" type="button" class="layui-btn">Apply</button>
                                                    </div>
                                                    <div class="layui-row" id="imageGrid" style="padding: 10px;"></div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>`

                    chartGeneratorLayerindex = layer.open({
                        type: 1, // page 层类型
                        area: ['800px', '600px'],
                        title: 'Chart Generator',
                        shade: 0, // 遮罩透明度
                        shadeClose: false, // 点击遮罩区域，关闭弹层
                        maxmin: true, // 允许全屏最小化
                        anim: 0, // 0-6 的动画形式，-1 不开启
                        content: settingDOM,
                        btn: ['Close'],
                        yes: function (index, layero) {
                            // 关闭弹出层时清除 index
                            layer.close(index);
                            chartGeneratorLayerindex = null;
                        },
                        // 监听弹出层关闭事件，不管是点击背景，点击关闭按钮，还是通过 API 关闭
                        end: function () {
                            chartGeneratorLayerindex = null;
                        },
                        success: function (layero, index) {
                            let charts = chart_type
                            let selectElement = document.getElementById('selectchart');
                            charts.forEach(item => {
                                const option = document.createElement('option');
                                option.value = item;
                                option.textContent = item;
                                selectElement.appendChild(option);
                            });

                        }
                    });

                },
                'applychart': function () {

                    let chartype = document.getElementById("selectchart").value

                    let chartdataset = getRecordsById(echart_dataset, chartype)

                    function renderImages(chartdataset) {
                        const container = document.getElementById('imageGrid');
                        container.innerHTML = ''; // 清空原内容

                        chartdataset.forEach(ele => {
                            const col = document.createElement('div');
                            col.className = 'layui-col-xs6 layui-col-sm4 layui-col-md3'; // xs一行2个，sm一行3个，md一行4个

                            const img = document.createElement('img');
                            img.src = ele['picturelink'];
                            img.style.width = '100%';
                            img.style.height = 'auto';
                            img.style.display = 'block';
                            img.style.padding = '5px';
                            img.style.cursor = 'pointer';


                            img.setAttribute('lay-on', 'chartEvent');
                            img.setAttribute('data', ele['chartname']);

                            col.appendChild(img);
                            container.appendChild(col);
                        });
                    }

                    renderImages(chartdataset)

                    function getRecordsById(dataset, targetId) {
                        return dataset.filter(item => item.id === targetId);
                    }

                    // function getAllPictureLinks(dataset) {
                    //     return dataset.map(item => item.picturelink).filter(Boolean);
                    // }

                },
                'chartEvent': function (othis) {

                    if (typeof CodeMirror === 'undefined') {
                        alert('loading,please wait a minute')
                        return
                    }

                    let chartname = othis[0].getAttribute('data')
                    let current_chart = echart_dataset.filter(item => item.chartname === chartname);
                    current_chart = current_chart[0]

                    if (current_chart['option_code'] == '') {
                        alert('someting error')
                        return
                    }

                    if (containsAny(str = current_chart['option_code'], keywords = ["ROOT_PATH"])) {
                        alert("Complex charts, need to be set up manually")
                    }

                    let noteforcustomized = ''
                    let chartnameDom = `<h2 class="chart-title">${current_chart['chartname']}</h2>`
                    let note = `<h4 class="chart-title">A chart inserted into an article cannot be previewed inside the editor, only preview in new tab</h4>`
                    let ainote = `AI Assistant can be used to quickly generate charts, shortcut prompts in the 'AI Assistant' catalog 'Echart' tag`
                    let layid = '12'
                    let content = `<div class="chart-title">${ainote}</div>
                ${chartnameDom}${noteforcustomized}<div id="chart-wrapper"></div>
                <div class="btn-c-1"><button id="insertchart" class="layui-btn layui-btn-warm">Insert chart to post</button><button id="asyncUpdateChart" class="layui-btn layui-btn-warm">Update Chart</button><a class="link-aichart" href="${current_chart['chartlink']}" target="_blank" class="m5Qfy" >Demo Office Link</a></div>${note}<textarea class="jsonEditor" id="jsonEditor-aichart"></textarea>`
                    var title = '2.Base'
                    mtabchange(layid, title, content)

                    editor = CodeMirror.fromTextArea(document.getElementById('jsonEditor-aichart'), {
                        lineNumbers: true,
                        mode: 'javascript',
                        theme: 'default',
                        tabSize: 2,
                        lineWrapping: true,
                    });

                    var id = 'chart_' + Date.now();
                    let chart = generate_chart(containerid = id, dataset = current_chart['option_code'])

                    // editor.setValue(current_chart['option_code'])

                    editor.setValue(chart['js'])
                    editor.setSize("100%", "600px");
                    // 强制刷新 CodeMirror，解决初始化时不显示内容的问题
                    setTimeout(function () {
                        editor.refresh();
                    }, 100);

                    setTimeout(() => {
                        editor.execCommand('selectAll');
                        editor.execCommand('indentAuto');
                    }, 0);

                    // formatJSON('jsonEditor-aichart')   

                    document.getElementById('asyncUpdateChart').addEventListener('click', () => {
                        // alert('cc')
                        let lastDataset = editor.getValue()
                        let chart = generate_chart(containerid = id, dataset = lastDataset)

                        $('#chart-wrapper').empty();
                        insertAndRunChartCode('#chart-wrapper', chart['js'], id)
                    })
                    document.getElementById('insertchart').addEventListener('click', () => {

                        let lastDataset = editor.getValue()
                        let chart = generate_post_chart(containerid = id, dataset = lastDataset)
                        insertHtmlAtCursorOrEnd(chart)
                    })
                    insertAndRunChartCode('#chart-wrapper', chart['js'], id);
                },

            })
        })
    })
})

function insertAndRunChartCode(targetSelector, jsCode, containerID) {
    var $ = layui.$;
    $(targetSelector).append(`<div id="${containerID}" style="width:100%;height:480px;"></div>`);
    let finalCode = jsCode
    new Function(finalCode)();
}

function generate_chart(containerid, dataset, chartype = 1) {
    let containerDom = `<div id="${containerid}" style="width:100%;height:480px;"></div>`
    let js = `
             var chartDom = document.getElementById('${containerid}');
             var myChart = echarts.init(chartDom);
             var option;
             ${dataset}
             option && myChart.setOption(option);
             window.addEventListener('resize', () => chart.resize());
    `
    finalchart = { 'containerDom': containerDom, 'js': js }
    return finalchart
}

function generate_post_chart(containerid, dataset) {
    let finalchart = `<div id="${containerid}" style="width:100%;height:480px;"></div>
    <script type="module">
            var chartDom = document.getElementById('${containerid}');
             var myChart = echarts.init(chartDom);
             var option;
            ${dataset}
             option && myChart.setOption(option);
             window.addEventListener('resize', () => chart.resize());
    </script>`
    return finalchart
}

function insertHtmlAtCursorOrEnd(content) {
    const selectedBlockId = wp.data.select('core/block-editor').getBlockSelectionStart();
    const blocks = wp.data.select('core/block-editor').getBlocks();
    let insertIndex = blocks.length; // 默认插在最后

    if (selectedBlockId) {
        const selectedIndex = blocks.findIndex(block => block.clientId === selectedBlockId);
        if (selectedIndex !== -1) {
            insertIndex = selectedIndex + 1;
        }
    }

    const newBlock = wp.blocks.createBlock('core/html', {
        content: content
    });

    wp.data.dispatch('core/block-editor').insertBlocks(newBlock, insertIndex);
}


var chart_type = [
    "chart-row-line",
    "chart-row-bar",
    "chart-row-pie",
    "chart-row-scatter",
    "chart-row-map",
    "chart-row-candlestick",
    "chart-row-radar",
    "chart-row-boxplot",
    "chart-row-heatmap",
    "chart-row-graph",
    "chart-row-lines",
    "chart-row-tree",
    "chart-row-treemap",
    "chart-row-sunburst",
    "chart-row-parallel",
    "chart-row-sankey",
    "chart-row-funnel",
    "chart-row-gauge",
    "chart-row-pictorialBar",
    "chart-row-themeRiver",
    "chart-row-calendar",
    "chart-row-custom",
    "chart-row-dataset",
    "chart-row-dataZoom",
    "chart-row-graphic",
    "chart-row-rich",
    "chart-row-globe",
    "chart-row-bar3D",
    "chart-row-scatter3D",
    "chart-row-surface",
    "chart-row-map3D",
    "chart-row-lines3D",
    "chart-row-line3D",
    "chart-row-scatterGL",
    "chart-row-linesGL",
    "chart-row-flowGL",
    "chart-row-graphGL"
]

function containsAny(str, keywords) {
    return keywords.some(keyword => str.includes(keyword));
}