<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Screenshot & Record</title>
</head>

<style>
    body {
        font-family: Arial, sans-serif;
        margin: 20px;
        padding: 0;
        background-color: #f5f5f5;
    }

    h1 {
        text-align: center;
    }

    #app {
        width: 80%;
        margin: 0 auto;
        padding: 20px;
        background-color: white;
        border-radius: 10px;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
    }

    button {
        margin: 10px;
        padding: 10px 20px;
        background-color: #007bff;
        color: white;
        border: none;
        border-radius: 5px;
        cursor: pointer;
    }

    button:hover {
        background-color: #0056b3;
    }

    canvas {
        border: 1px solid #ccc;
    }

    .screenshot-item {
        margin: 10px;
        position: relative;
    }

    .screenshot-item input[type="checkbox"] {
        position: absolute;
        top: 5px;
        left: 5px;
        background-color: rgba(255, 255, 255, 0.7);
        border-radius: 50%;
        padding: 5px;
    }

    /* New grid style for thumbnails */
    .screenshots {
        display: grid;
        grid-template-columns: repeat(3, 1fr);
        /* 3 columns */
        gap: 15px;
        justify-items: center;
    }

    /* Thumbnail image styling */
    .screenshot-item img {
        max-width: 100%;
        height: auto;
        border: 3px solid #ddd;
        border-radius: 8px;
        transition: transform 0.3s, box-shadow 0.3s;
    }

    /* Hover effect for images */
    .screenshot-item img:hover {
        /* transform: scale(1.05); */
        box-shadow: 0 4px 10px rgba(0, 0, 0, 0.15);
    }

    /* Styling the progress bar */
    #progress {
        margin-top: 10px;
        height: 20px;
        background-color: #e0e0e0;
        border-radius: 10px;
        overflow: hidden;
    }

    #progress-bar {
        height: 100%;
        background-color: #28a745;
        width: 0;
    }

    .loading {
        cursor: not-allowed;
        background-color: #6c757d;
    }

    h2 {
        font-size: 2em;
        color: #4CAF50;
        margin-bottom: 20px;
        border-bottom: 2px solid #4CAF50;
        padding-bottom: 10px;
    }

    .link-list {
        list-style: none;
        padding: 0;
        margin: 0;
    }

    .link-list li {
        background-color: #fff;
        padding: 15px;
        margin-bottom: 15px;
        border-radius: 8px;
        box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
        transition: all 0.3s ease;
    }

    .link-list li:hover {
        transform: translateY(-5px);
        box-shadow: 0 6px 10px rgba(0, 0, 0, 0.2);
    }

    .link-list a {
        color: #4CAF50;
        font-size: 1.1em;
        text-decoration: none;
        word-wrap: break-word;
        display: block;
    }

    .link-list a:hover {
        color: #45a049;
        text-decoration: underline;
    }

    /* .link-list li:before {
        content: "•";
        color: #4CAF50;
        font-size: 20px;
        margin-right: 10px;
    } */

    .link-list li::after {
        content: "";
        display: block;
        margin-top: 10px;
        border-bottom: 1px solid #ddd;
    }
</style>

<body>
    <div id="app">

        <h2>Download YouTube Video Website List</h2>

        <ul class="link-list">
            <li>
                Kindly note: Free tools may come with ads!
            </li>
            <li>
                <a href="https://www.socialplug.io/free-tools/youtube-video-downloader" target="_blank">
                    https://www.socialplug.io/free-tools/youtube-video-downloader
                </a>
            </li>
            <li>
                <a href="https://yt1s.com.co/download/" target="_blank">
                    https://yt1s.com.co/download/
                </a>
            </li>
            <li>
                <a href="https://www.google.com/search?q=youtube+video+download+online" target="_blank">
                    https://www.google.com/search?q=youtube+video+download+online
                </a>
            </li>
            <!-- 可以继续添加更多的链接项 -->
        </ul>

        <h1>Screenshot & Record</h1>

        <input type="file" @change="loadVideo" accept="video/*">
        <div v-if="videoLoaded">
            <video ref="video" controls :src="videoSrc" width="640"></video>

            <!-- <div>
                <label for="screenshotTime">输入截图时间（秒）:</label>
                <input type="number" id="screenshotTime" v-model="screenshotTime" min="0" step="1">
                <button @click="setScreenshotTime">设置截图时间</button>
            </div> -->

            <div>
                <label for="screenshotTimeHours">Hour:</label>
                <input type="number" id="screenshotTimeHours" v-model="screenshotTimeHours" min="0" step="1">

                <label for="screenshotTimeMinutes">Minutes:</label>
                <input type="number" id="screenshotTimeMinutes" v-model="screenshotTimeMinutes" min="0" step="1" max="59">

                <label for="screenshotTimeSeconds">Seconds:</label>
                <input type="number" id="screenshotTimeSeconds" v-model="screenshotTimeSeconds" min="0" step="1" max="59">

                <button @click="setScreenshotTime">Setting the screenshot time</button>
            </div>

            <button @click="captureFrame">Screenshot</button>
            <button :class="{ loading: isRecording }" @click="startRecording" :disabled="isRecording">Start recording</button>
            <button @click="stopRecording" :disabled="!isRecording">Stop recording</button>
            <!-- <button :class="{ loading: isGifCreating }" @click="createGif" :disabled="isGifCreating">生成 GIF</button> -->

            <div v-if="screenshots.length > 0">
                <h3>Screenshot List</h3>
                <button @click="selectAllScreenshots">Select All/Cancel All</button>
                <button @click="InsertSelectedScreenshots">Insert selected screenshot</button>
                <button @click="clearSelectedScreenshots">Clear selected screenshots</button> <!-- New button -->

                <div class="screenshots">
                    <div v-for="(screenshot, index) in screenshots" :key="index" class="screenshot-item">
                        <input type="checkbox" v-model="selectedScreenshots" :value="screenshot">
                        <img :src="screenshot" alt="">
                    </div>
                </div>
            </div>

            <canvas ref="canvas" style="display:none;"></canvas>

            <div v-if="recordedVideoSrc">
                <h3>Recorded video</h3>
                <!-- 显示录制的视频 -->
                <video :src="recordedVideoSrc" controls width="640"></video>

                <!-- <button @click="insertVideoToEditor" class="btn btn-primary">Inserting a video into the editor</button> -->


                <!-- 下载按钮 -->
                <button @click="downloadVideo" class="btn btn-primary">Download Video</button>

                <!-- 复制按钮 -->
                <!-- <button @click="copyVideo" class="btn btn-secondary">Copy Video</button> -->
            </div>


            <!-- <div v-if="gifGenerated">
                <h3>生成的 GIF</h3>
                <img :src="gifSrc" alt="GIF">
            </div> -->

            <!-- <div v-if="gifGenerated">
                <h3>生成的 GIF</h3>
                <img :src="gifSrc" alt="GIF" width="640">
            </div> -->

            <!-- 进度条 -->
            <!-- <div id="progress" v-if="isGifCreating || isRecording">
                <div id="progress-bar" :style="{ width: progress + '%' }"></div>
            </div> -->
        </div>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/gif.js/0.2.0/gif.js" integrity="sha512-nNOFtIS+H0lwgdUDaPn/g1ssw3uN9AkEM7zy2wLaTQeLQNeNiitUcLpEpDIh3Z4T22MdeTNru/SQbNM4ig2rng==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

    <script>
        document.addEventListener('DOMContentLoaded', function() {
            new Vue({
                el: '#app',
                data() {
                    return {
                        screenshotTimeHours: 0,
                        screenshotTimeMinutes: 0,
                        screenshotTimeSeconds: 0,
                        screenshotTimeInSeconds: 0, // 存储总秒数
                        videoSrc: null, // 视频文件路径
                        videoLoaded: false, // 视频是否加载
                        screenshots: [], // 存储截图的数组
                        selectedScreenshots: [], // 存储选中的截图
                        gifGenerated: false, // GIF是否已生成
                        gifSrc: null, // GIF路径
                        mediaRecorder: null, // 录制器实例
                        chunks: [], // 录制的数据
                        // screenshotTime: 0, // 用户输入的截图时间（秒）
                        recordedVideoSrc: null, // 录制的视频URL
                        isRecording: false, // 是否正在录制
                        isGifCreating: false, // 是否正在创建 GIF
                        progress: 0, // 进度条百分比
                        maxScreenshots: 10 // 最大截图数量
                    };
                },
                methods: {
                    setScreenshotTimes() {
                        // 将输入的小时、分钟、秒转换为总秒数
                        this.screenshotTimeInSeconds = (this.screenshotTimeHours * 3600) + (this.screenshotTimeMinutes * 60) + this.screenshotTimeSeconds * 1;
                        console.log('截图时间（秒）:', this.screenshotTimeInSeconds);

                        // 如果需要，将总秒数传给其他地方或保存
                        // 比如调用某个API或执行其他操作
                    },
                    // 加载本地视频
                    loadVideo(event) {
                        const file = event.target.files[0];
                        if (file && file.type.startsWith('video/')) {
                            this.videoSrc = URL.createObjectURL(file);
                            this.videoLoaded = true;
                        } else {
                            alert("Please upload a valid video file!");
                        }
                    },

                    // 截图功能（包括压缩）
                    captureFrame() {
                        if (this.screenshots.length >= this.maxScreenshots) {
                            this.screenshots.shift(); // 移除最旧的截图
                        }

                        const video = this.$refs.video;
                        const canvas = this.$refs.canvas;
                        const context = canvas.getContext('2d');

                        const videoWidth = video.videoWidth;
                        const videoHeight = video.videoHeight;

                        canvas.width = videoWidth;
                        canvas.height = videoHeight;

                        const dpr = window.devicePixelRatio || 1;

                        canvas.width = videoWidth * dpr;
                        canvas.height = videoHeight * dpr;

                        context.scale(dpr, dpr); // 高DPI显示

                        context.drawImage(video, 0, 0, videoWidth, videoHeight);

                        // 压缩图片并转为Blob格式
                        canvas.toBlob((blob) => {
                            // 将压缩后的图片转为base64格式
                            const compressedImageUrl = URL.createObjectURL(blob);

                            // 将压缩后的图片保存到截图数组
                            this.screenshots.push(compressedImageUrl);

                        }, 'image/jpeg', 0.7); // 图片格式为JPEG，质量为0.7（30%压缩）
                    },

                    // 设置截图时间并跳转
                    setScreenshotTime() {
                        this.setScreenshotTimes()
                        const video = this.$refs.video;
                        const time = parseFloat(this.screenshotTimeInSeconds);
                        if (video && !isNaN(time) && time >= 0) {
                            video.currentTime = time;
                            // this.scheduleScreenshot(time);
                        }
                    },

                    // 安排截图
                    scheduleScreenshot(time) {
                        const video = this.$refs.video;
                        const timeout = (time - video.currentTime) * 1000;

                        if (timeout <= 0) {
                            this.captureFrame();
                        } else {
                            setTimeout(() => {
                                this.captureFrame();
                            }, timeout);
                        }
                    },

                    // 选择/取消选择所有截图
                    selectAllScreenshots() {
                        if (this.selectedScreenshots.length === this.screenshots.length) {
                            this.selectedScreenshots = []; // 取消全选
                        } else {
                            this.selectedScreenshots = [...this.screenshots]; // 选择所有截图
                        }
                    },

                    // 插入选中的截图
                    InsertSelectedScreenshots() {
                        if (this.selectedScreenshots.length > 0) {
                            layer.msg('insert Done')
                            const selectedImages = this.selectedScreenshots;
                            const clipboardItems = selectedImages.map(screenshotUrl => {
                                return fetch(screenshotUrl)
                                    .then(response => response.blob())
                                    .then(blob => {
                                        return new Promise((resolve, reject) => {
                                            const reader = new FileReader();
                                            reader.onloadend = () => resolve(reader.result);
                                            reader.onerror = reject;
                                            reader.readAsDataURL(blob);
                                        });
                                    });
                            });

                            Promise.all(clipboardItems)
                                .then(base64Images => {
                                    sendToParent(base64Images);
                                })
                                .catch(err => {
                                    console.error('Error creating Base64:', err);
                                });

                            function sendToParent(base64Images) {
                                window.parent.postMessage({
                                    type: 'base64Images',//信号，在assistant.js查找处理事件
                                    data: base64Images
                                }, '*');
                            }
                        } else {
                            alert("Please select screenshot first！");
                        }
                    },

                    // 清除选中的截图
                    clearSelectedScreenshots() {
                        if (this.selectedScreenshots.length > 0) {
                            // Remove selected screenshots from the array
                            this.screenshots = this.screenshots.filter(screenshot => !this.selectedScreenshots.includes(screenshot));
                            this.selectedScreenshots = []; // Clear selected screenshots array
                        } else {
                            alert("Please select screenshot first！");
                        }
                    },

                    // 开始录制功能
                    startRecording() {
                        const video = this.$refs.video;
                        video.play(); // Play the video when recording starts
                        const stream = video.captureStream();
                        this.mediaRecorder = new MediaRecorder(stream);
                        this.mediaRecorder.ondataavailable = (event) => {
                            this.chunks.push(event.data);
                        };
                        this.mediaRecorder.onstop = this.handleRecordingStop;
                        this.mediaRecorder.start();
                        this.isRecording = true;
                    },

                    stopRecording() {
                        const video = this.$refs.video;
                        if (this.mediaRecorder) {
                            this.mediaRecorder.stop();
                        }
                        video.pause(); // Pause the video when recording stops
                        this.isRecording = false;
                    },




                    handleRecordingStop() {
                        const blob = new Blob(this.chunks, {
                            type: 'video/mp4'
                        });
                        this.recordedVideoSrc = URL.createObjectURL(blob); // 创建 Blob URL

                        // // 将 Blob 转为 Base64 字符串
                        // this.convertBlobToBase64(blob).then(base64Video => {
                        //     // 发送 Base64 编码的视频到父窗口
                        //     window.parent.postMessage({
                        //         type: 'insertVideo',
                        //         data: base64Video // 这里传递 Base64 编码的视频
                        //     }, '*');
                        // }).catch(error => {
                        //     console.error('视频转 Base64 出错:', error);
                        // });

                        this.chunks = []; // 清空录制的 chunks
                        this.isRecording = false; // 停止录制
                    },

                    insertVideoToEditor() {
                        if (this.recordedVideoSrc) {
                            const video = document.createElement('video');
                            video.src = this.recordedVideoSrc;

                            // 检查视频格式，提示用户转换
                            const isWebM = video.src.endsWith('.webm');
                            if (isWebM) {
                                // 这里可以用FFmpeg.js进行格式转换，或者上传服务器端转换
                                alert("ERROR");
                                return;
                            }

                            // 获取 Blob 数据并转换为 Base64
                            fetch(this.recordedVideoSrc)
                                .then(response => response.blob())
                                .then(blob => this.convertBlobToBase64(blob)) // 转换为 Base64
                                .then(base64Data => {
                                    // 发送消息到父窗口，插入视频（以 Base64 格式）
                                    window.parent.postMessage({
                                        type: 'insertVideo',
                                        data: base64Data // 传递 Base64 格式的视频数据
                                    }, '*');
                                })
                                .catch(error => {
                                    console.error(error);
                                });
                        }
                    },


                    // 将 Blob 转换为 Base64 编码
                    convertBlobToBase64(blob) {
                        return new Promise((resolve, reject) => {
                            const reader = new FileReader();
                            reader.onloadend = () => resolve(reader.result); // 转换成功时返回 Base64 字符串
                            reader.onerror = reject; // 转换失败时返回错误
                            reader.readAsDataURL(blob); // 将 Blob 转为 Base64
                        });
                    },

                    downloadVideo() {
                        if (this.recordedVideoSrc) {
                            const a = document.createElement('a');
                            a.href = this.recordedVideoSrc;
                            a.download = 'recorded-video.mp4'; // 设置下载文件名
                            a.click(); // 触发下载
                        }
                    },

                    // 复制录制的视频到剪贴板
                    copyVideo() {
                        if (this.recordedVideoSrc) {
                            fetch(this.recordedVideoSrc)
                                .then(response => response.blob())
                                .then(blob => {
                                    const reader = new FileReader();
                                    reader.onloadend = () => {
                                        const base64Video = reader.result;
                                        // 通过 Clipboard API 复制到剪贴板
                                        navigator.clipboard.writeText(base64Video)
                                            .then(() => {
                                                alert("The video has been copied to the clipboard!");
                                            })
                                            .catch(err => {
                                                console.error("复制到剪贴板时出错:", err);
                                                alert("Copying failed, please try again later.");
                                            });
                                    };
                                    reader.readAsDataURL(blob); // 将 Blob 转为 Base64 数据
                                })
                                .catch(err => {
                                    console.error("获取视频 Blob 出错:", err);
                                });
                        }
                    },

                    // 创建GIF
                    async createGif() {
                        this.isGifCreating = true;
                        const blob = new Blob(this.chunks, {
                            type: 'video/mp4'
                        });
                        const videoURL = URL.createObjectURL(blob); // 创建Blob URL
                        const video = document.createElement('video');
                        video.src = videoURL;

                        video.onloadeddata = () => {
                            const gif = new GIF({
                                workers: 2,
                                quality: 10,
                                width: video.videoWidth,
                                height: video.videoHeight,
                            });

                            const canvas = document.createElement('canvas');
                            const context = canvas.getContext('2d');
                            video.play();

                            video.ontimeupdate = () => {
                                context.drawImage(video, 0, 0, canvas.width, canvas.height);
                                gif.addFrame(canvas, {
                                    copy: true,
                                    delay: 100
                                });

                                this.progress = (video.currentTime / video.duration) * 100;
                            };

                            video.onended = () => {
                                gif.on('finished', (blob) => {
                                    // 创建GIF的URL
                                    this.gifSrc = URL.createObjectURL(blob); // 保证Gif的Blob URL有效
                                    this.gifGenerated = true;
                                    this.isGifCreating = false;
                                    // 如果你希望停止播放video，可以在这里暂停视频
                                    video.pause();
                                });
                                gif.render();
                            };
                        };

                        // 确保 video 的 Blob URL 不被提前释放
                        this.videoURL = videoURL; // 保存 videoURL，以避免它被垃圾回收
                    }


                }
            });
        });
    </script>
</body>

</html>